
--If the database already exists but you want to create it
--again, use the following lines. Just remove the -- at
--the beginning of the following 2 lines.

--DROP DATABASE IF EXISTS Forum; 
--CREATE DATABASE Forum;

USE Forum;

DROP TABLE IF EXISTS Forum;

CREATE TABLE Forum (
  id           INTEGER UNSIGNED NOT NULL auto_increment,
  name         VARCHAR(100) NOT NULL,
  description  TEXT,
PRIMARY KEY(id) );

DROP TABLE IF EXISTS Topic;

CREATE TABLE Topic (
  parent_forum  INTEGER UNSIGNED NOT NULL,
  id            INTEGER UNSIGNED NOT NULL auto_increment,
  name          VARCHAR(100) NOT NULL,
  description   TEXT,
PRIMARY KEY(id) );

DROP TABLE IF EXISTS Thread;

CREATE TABLE Thread (
  parent_topic INTEGER UNSIGNED NOT NULL,
  id           INTEGER UNSIGNED NOT NULL auto_increment,
  subject      TEXT NOT NULL,
  replies      INTEGER UNSIGNED,
  last_post    TIMESTAMP,
PRIMARY KEY(id) );

DROP TABLE IF EXISTS Post;

CREATE TABLE Post (
  parent_thread INTEGER UNSIGNED NOT NULL,
  in_reply_to   INTEGER UNSIGNED,
  id            INTEGER UNSIGNED NOT NULL auto_increment,
  author        VARCHAR(100) NOT NULL,
  date          TIMESTAMP,
  body          TEXT,
PRIMARY KEY(id) );

